import { DeepPartial } from '@azure-tools/codegen';
import { Access, New, ReadOnly, Static, Volitile } from './access-modifier';
import { Attribute } from './attribute';
import { Expression, ExpressionOrLiteral } from './expression';
import { OneOrMoreStatements, Statement } from './statements/statement';
import { TypeDeclaration } from './type-declaration';
import { Variable } from './variable';
/** represents a field in a Class */
export declare class Field extends Variable {
    name: string;
    type: TypeDeclaration;
    'new': New;
    access: Access;
    'static': Static;
    'readonly': ReadOnly;
    volitile: Volitile;
    attributes: Attribute[];
    initialValue?: ExpressionOrLiteral;
    protected readonly attributeDeclaration: string;
    description: string;
    constructor(name: string, type: TypeDeclaration, objectInitializer?: DeepPartial<Field>);
    readonly declaration: string;
    readonly value: string;
    assign(expression: ExpressionOrLiteral): OneOrMoreStatements;
    assignPrivate(expression: ExpressionOrLiteral): OneOrMoreStatements;
    readonly declarationExpression: Expression;
    readonly declarationStatement: Statement;
}
//# sourceMappingURL=field.d.ts.map