import { Attribute } from './attribute';
import { Expression, ExpressionOrLiteral } from './expression';
import { ParameterModifier } from './parameter-modifier';
import { OneOrMoreStatements, Statement } from './statements/statement';
import { TypeDeclaration } from './type-declaration';
import { Variable } from './variable';
import { DeepPartial } from '@azure-tools/codegen';
/** represents a method parameter */
export declare class Parameter extends Variable {
    name: string;
    type: TypeDeclaration;
    description: string;
    genericParameters: string[];
    where?: string;
    params: boolean;
    modifier: ParameterModifier;
    defaultInitializer?: Expression;
    attributes: Attribute[];
    protected readonly attributeDeclaration: string;
    constructor(name: string, type: TypeDeclaration, objectInitializer?: DeepPartial<Parameter>);
    readonly comment: string;
    readonly declaration: string;
    readonly use: string;
    readonly value: string;
    assign(expression: ExpressionOrLiteral): OneOrMoreStatements;
    assignPrivate(expression: ExpressionOrLiteral): OneOrMoreStatements;
    readonly declarationExpression: Expression;
    readonly declarationStatement: Statement;
}
//# sourceMappingURL=parameter.d.ts.map